﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.FormattedLinkLabel;
using Infragistics.Win.UltraWinEditors;

namespace Summary
{
    public partial class Form1 : Form
    {
        private const int ROWS = 100;
        private const int COLS = 10;

        private DataTable table = null;

        private UltraGridCell lastActiveCell = null;
        private UltraGridRow lastActiveRow = null;

        public Form1()
        {
            this.InitializeComponent();

            this.grid.TextRenderingMode = TextRenderingMode.GDI;
            this.grid.Font = new Font(this.Font.FontFamily, 12f);
            this.grid.InitializeLayout += new InitializeLayoutEventHandler(grid_InitializeLayout);
            this.grid.DataSource = this.Table;
            this.grid.BeforeRowDeactivate += new CancelEventHandler(grid_BeforeRowDeactivate);
            this.grid.BeforeCellActivate += new CancelableCellEventHandler(grid_BeforeCellActivate);
            this.grid.BeforeCellDeactivate += new CancelEventHandler(grid_BeforeCellDeactivate);
        }

        void grid_BeforeCellDeactivate(object sender, CancelEventArgs e)
        {
            this.lastActiveCell = this.grid.ActiveCell;
        }

        void grid_BeforeCellActivate(object sender, CancelableCellEventArgs e)
        {
            if ( e.Cell.Column.Key == "FormattedText" )
            {
                e.Cancel = true;

                if ( this.lastActiveCell != null )
                    this.lastActiveCell.Activate();
                else
                if ( this.lastActiveRow != null )
                    this.lastActiveRow.Activate();
            }
        }

        void grid_BeforeRowDeactivate(object sender, CancelEventArgs e)
        {
            this.lastActiveRow = this.grid.ActiveRow;
        }

        void grid_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            //e.Layout.Bands[0].Columns["FormattedText"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;

            e.Layout.Bands[0].Columns["FormattedText"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.FormattedText;
        }

        private DataTable Table
        {
            get
            {
                if ( this.table == null )
                {
                    this.table = new DataTable();


                    this.table.Columns.Add("Name", typeof(string));
                    this.table.Columns.Add("Number", typeof(int));
                    this.table.Columns.Add("FormattedText", typeof(string));

                    this.table.Rows.Add( new object[]{ "One", 1, "This text is <span style=\"color: #FF0000;\">RED</span>" } );
                    this.table.Rows.Add( new object[]{ "Two", 2, "This text is <span style=\"color: #008000;\">GREEN</span>" } );
                    this.table.Rows.Add( new object[]{ "Three", 3, "This text is <span style=\"color: #0000FF;\">BLUE</span>" } );
                }

                return this.table;
            }
        }

    }

}
